/* YaRock Player
* Copyright (C) 2010-2013 Sebastien amardeilh (sebastien.amardeilh+yarock@gmail.com)
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef _COLLECTION_POPULATOR_H_
#define _COLLECTION_POPULATOR_H_

#include <QThread>
#include <QObject>
#include <QTimer>

class CollectionModel;
class EnginePlayer;

/*
********************************************************************************
*                                                                              *
*    Class CollectionPopulator                                                 *
*                                                                              *
********************************************************************************
*/
class CollectionPopulator :  public QThread
{
Q_OBJECT
public:
    explicit CollectionPopulator();
    void setExit(bool b) {_exit = b;}

protected:
    void run();

private:
    CollectionModel    *_collectionModel;
    bool               _exit;
    QTimer             *_populatorTimer;
    
signals:
    void populatingFinished();
    void populatingProgress(int);
    void populatingRunning();
};

#endif // _COLLECTION_POPULATOR_H_
