/* YaRock Player
* Copyright (C) 2010-2013 Sebastien amardeilh (sebastien.amardeilh+yarock@gmail.com)
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef _HISTOMODEL_H_
#define _HISTOMODEL_H_


#include <QList>
#include <QString>
#include <QObject>
#include <QMutex>

#include "MediaItem/mediaitem.h"

/*
********************************************************************************
*                                                                              *
*    Class HistoModel                                                          *
*                                                                              *
********************************************************************************
*/
class HistoModel  : public QObject
{
Q_OBJECT
    static HistoModel*   INSTANCE;

  public:
    HistoModel(QObject *parent);
    static HistoModel* instance() { return INSTANCE; }    
     
    void updateModel();
        
    int itemCount() {return m_listMediaItem.size();}
    MediaItemPtr getItem(int row);

    //! playing status method
    void     stopPlayingItem();
    void     updatePlayingItem(const QString& url);

    //! broken status method
    void     updateBrokenItem(const QString& url);
    
    //! filtering method
    bool isItemFiltered(const int row);
    void setFilter(const QString & f) {m_filter_pattern = f;}
         
    void clear();

  signals:
    void signalPlayingStatusChanged();
    
  private:
    QList<MediaItemPtr>   m_listMediaItem;
    int                   m_playing_item_idx;    
    QMutex                m_mutex;
    QString               m_filter_pattern;
};

#endif // _HISTOMODEL_H_ 
