/* YaRock Player
* Copyright (C) 2010-2013 Sebastien amardeilh (sebastien.amardeilh+yarock@gmail.com)
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "Dialog/dboperationdialog.h"

#include <QDialogButtonBox>
#include <QGroupBox>
#include <QVBoxLayout>
#include <QLabel>

/*
********************************************************************************
*                                                                              *
*    Class DbOperationDialog                                                   *
*                                                                              *
********************************************************************************
*/

DbOperationDialog::DbOperationDialog(QWidget *parent) : QDialog(parent)
{
    // create Gui
    createGui();

}

//! ----------- createGui ------------------------------------------------------
void DbOperationDialog::createGui()
{
    this->resize(445, 150);
    this->setWindowTitle(QString::fromUtf8("Database operation"));
    
    QDialogButtonBox *buttonBox = new QDialogButtonBox(this);
    buttonBox->setGeometry(QRect(140, 110, 291, 32));
    buttonBox->setOrientation(Qt::Horizontal);
    buttonBox->setStandardButtons(QDialogButtonBox::Cancel|QDialogButtonBox::Ok);

    QGroupBox *groupBox = new QGroupBox(tr("Choose database operation"));
    groupBox->setFlat ( true );

    ui_check_updateScan = new QRadioButton( tr("Rescan medias files and update database") );
    ui_check_fullScan   = new QRadioButton( tr("Delete and rebuild database (*)") );
    
    QLabel *label =  new QLabel("* all changes into collection database will be discarded !!");
    
    QVBoxLayout *vbox = new QVBoxLayout;
    vbox->addWidget(ui_check_updateScan);
    vbox->addWidget(ui_check_fullScan);
    vbox->addWidget(label);    
    groupBox->setLayout(vbox);

    QVBoxLayout* vl0 = new QVBoxLayout(this);
    vl0->addWidget(groupBox);
    vl0->addStretch(1);
    
    QObject::connect(buttonBox, SIGNAL(accepted()), this, SLOT(on_buttonBox_accepted()));
    QObject::connect(buttonBox, SIGNAL(rejected()), this, SLOT(on_buttonBox_rejected()));    
}

bool DbOperationDialog::isFullRescan() 
{
  return ui_check_fullScan->isChecked();
}



//! --------- on_buttonBox_accepted --------------------------------------------
void DbOperationDialog::on_buttonBox_accepted()
{
    this->setResult(QDialog::Accepted);
    QDialog::accept();
    this->close();
}


//! --------- on_buttonBox_rejected --------------------------------------------
void DbOperationDialog::on_buttonBox_rejected()
{
    this->setResult(QDialog::Rejected);
    QDialog::reject();
    this->close();
}

