/* YaRock Player
* Copyright (C) 2010-2013 Sebastien amardeilh (sebastien.amardeilh+yarock@gmail.com)
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef _PLAYLISTWIDGET_H_
#define _PLAYLISTWIDGET_H_

#include "Playlist/playlistview.h"
#include "Playlist/playlistmodel.h"

#include <QtGui/QWidget>
#include <QSignalMapper>
#include <QActionGroup>
#include <QAction>

/*
********************************************************************************
*                                                                              *
*    Class PlaylistWidget                                                      *
*                                                                              *
********************************************************************************
*/
class PlaylistWidget : public QWidget
{
Q_OBJECT
    static PlaylistWidget* INSTANCE;  

  public: 
    PlaylistWidget(QWidget *parent, PlaylistView *view);
    static PlaylistWidget* instance() { return INSTANCE; }    
  
    int mode() {return _playlistview->mode();}
    
  private:
    void contextMenuEvent ( QContextMenuEvent * event );
    void addMenuItem(QSignalMapper* mapper, QActionGroup* group,QAction* action, PLAYQUEUE::Q_MODE mode);

  private slots:
    void updatePlaylistWidget();
    void updatePlaylistActions();
    void updatePlaylistSummary();
    void playQueueModeChange(int mode);

  private :
    PlaylistView       *_playlistview;
    PlaylistModel      *_playlistmodel;
    QMenu              *_menu;
};


#endif // _PLAYLISTWIDGET_H_
