/* YaRock Player
* Copyright (C) 2010-2013 Sebastien amardeilh (sebastien.amardeilh+yarock@gmail.com)
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef _PLAYLISTWRITER_H_
#define _PLAYLISTWRITER_H_

#include <QRunnable>
#include <QObject>
#include <QList>
#include <QString>

#include "MediaItem/mediaitem.h"

class PlaylistModel;

/*
********************************************************************************
*                                                                              *
*    Class PlaylistWriter                                                      *
*                                                                              *
********************************************************************************
*/
//! PlaylistWriter saves current playlist to given file
class PlaylistWriter : public QObject, public QRunnable
{
Q_OBJECT
  public:
    explicit PlaylistWriter();
    
    bool isRunning() {return _isRunning;}
    
    void run();

    void saveToFile(const QString& filename);

    void setModel(PlaylistModel* m) {_playlistModel = m;};

  private:
    PlaylistModel     *_playlistModel;
    QString           _fileToSave;
    bool              _isRunning;
    
    void updateDatabase(QList<MediaItemPtr> list);
    
  signals:
    void playlistSaved();    
};

#endif // _PLAYLISTWRITER_H_
