/* YaRock Player
* Copyright (C) 2010-2013 Sebastien amardeilh (sebastien.amardeilh+yarock@gmail.com)
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef _XSPF_STREAM_LIST_H_
#define _XSPF_STREAM_LIST_H_


#include "MediaItem/mediaitem.h"

#include <QList>
#include <QString>

/*
********************************************************************************
*                                                                              *
*    Class XspfStreamList                                                      *
*                                                                              *
********************************************************************************
*/
class XspfStreamList
{
public:
    XspfStreamList();
    XspfStreamList(const QString& path);
    
    void read();
    
    void write();

    QList<MediaItemPtr> mediaList() {return m_mediaitem_list;}
    void setMediaList(QList<MediaItemPtr>);
    
    QString filename() {return m_filename;}
    void set_filename(const QString& path) {m_filename = path;}
    
    QString playlist_name() {return m_playlist_name;}
    void set_playlist_name(const QString& name) {m_playlist_name = name;}
    
private:
    QString               m_filename;
    
    QString               m_playlist_name;
    
    QList<MediaItemPtr>   m_mediaitem_list;
};


#endif // _XSPF_STREAM_LIST_H_
